using System;
using System.Text;
using System.Linq;
using System.Collections.Generic;
using System.Net.Sockets;

/// <summary>
/// Tehtävä 4-5
/// Salasanan generointi
/// </summary>
public class T4_T5_Salasana
{
    // Bonus: Miten ottaisit huomioon epäselvät merkit?
    public const string Epaselvat = "IlO0";

    public static void Main()
    {
        Random r = new Random();
        for (int i = 0; i < 10; i++)
        {
            Console.WriteLine(GeneroiSalasana(r, 10, true, true, true));
        }
    }

    /// <summary>
    /// Generoi salasanan annetuilla ehdoilla. Salasanassa esiintyvien merkkien
    /// todennäköisyys on seuraava:
    /// - kirjain 1/3
    /// - numero 1/3
    /// - erikoismerkki 1/3
    /// </summary>
    /// <param name="r">Satunnaisolio</param>
    /// <param name="pituus">Pituus</param>
    /// <param name="suuraakkosia">Voiko sisältää suuraakkosia</param>
    /// <param name="numeroita">Voiko sisältää numeroita</param>
    /// <param name="erikoismerkkeja">Voiko sisältää erikoismerkkejä</param>
    /// <returns></returns>
    public static string GeneroiSalasana(Random r, int pituus, bool suuraakkosia, bool numeroita, bool erikoismerkkeja)
    {
        const string aakkoset = "abcdefghijklmnopqrstuvwxyz";
        const string erikoismerkit = "!@#$%&-";

        StringBuilder salasana = new StringBuilder();
        for (int i = 0; i < pituus; i++)
        {
            // Arvotaan sekä aakkonen, erikoismerkki että numero.
            char aakkonen = aakkoset[r.Next(aakkoset.Length)];
            char erikoismerkki = erikoismerkit[r.Next(erikoismerkit.Length)];
            char numero = (char)r.Next('0', '9' + 1);
            if (suuraakkosia && r.NextDouble() > 0.5) aakkonen = char.ToUpper(aakkonen);
            
            // Tehdään arvotuista merkeistä merkkijono ("mahdolliset").
            string mahdolliset = "" + aakkonen;
            if (numeroita) mahdolliset += numero;
            if (erikoismerkkeja) mahdolliset += erikoismerkki;
            
            // Arvotaan mahdollisista merkeistä yksi. 
            salasana.Append(mahdolliset[r.Next(mahdolliset.Length)]);
        }
        return salasana.ToString();
    }
}